// canted state (2spins per magnetic UC) for lc_mf.ccm (magnetic field)
// - set UseAlpha in solve.C
// - use restriction=4 (no length=1 configs)
// ToDo: check signs via zero field case, angle=0,pi?
//
//     1a  1b    2a  2b    3a 3b   spins  ^
//    <--  -->  <--  -->  <-- -->         | field=D
//     -a  +a    -a  +a    -a  +a  angle
//   

#define _USR_PARAMETER_ "bonds == 1 field" // JS0910 mark function as declared
double usr_parameter(int bonds, double alpha)
{
    /* add your model specifique parameter here! H=sum_i u(i,alpha)*H_i */
  //  d1 * H1 + d2 * H2 + d3 * H3 + ...
  if (bonds==1) return alpha; // field
  if (bonds==2) return 1;     // nn
  return 0.0;
}

#define UseAlpha 1
#define StartAlpha    (0*M_PI/2.0)
// start=M_PI gives for alpha=0 m.n=6 +0.44002442 == (-Eg(LC6.6)) wrong
#define StepAlpha     (0.01*M_PI)         /* initial step of alpha, 0.001*M_PI */
#define SearchAlphaMin 1 /* 0=startAlpha_only or 1=fix_steps, 2=dynamic_search */

double usr_angle(int bond, int term13, double *alpha, int numalpha)
{

  // alpha: 0 (uc1: h+pi/2, uc2: h-pi/2)
  double mult = 0.0;  // default for other terms
  double phi1 =   alpha[0]; /* + M_PI was in the script ??? */
  double phi2 = 2*alpha[0];  // nn-neigbour 
  
  if (bond==1 ) {   // J2 bit now... ?? field!
    if      (term13 == 10) mult=    1.0*(sin(phi1));   // s^z
    else if (term13 == 11) mult=    0.5*(cos(phi1));   // s^-
    else if (term13 == 13) mult=    0.5*(cos(phi1));   // s^+
  } else if (bond==2 ) {  // J_1 bit now...
    if      (term13 ==  1) mult=    -1.0*cos(phi2);    // zz
    else if (term13 ==  2) mult=    -0.5*sin(phi2);    // z+
    else if (term13 ==  3) mult=    -0.5*sin(phi2);    // z-
    else if (term13 ==  4) mult=     0.5*sin(phi2);    // +z
    else if (term13 ==  5) mult=     0.5*sin(phi2);    // -z
    else if (term13 ==  6) mult=  -0.25*(cos(phi2)-1); // +-
    else if (term13 ==  7) mult=  -0.25*(cos(phi2)-1); // -+
    else if (term13 ==  8) mult=  -0.25*(cos(phi2)+1); // ++
    else if (term13 ==  9) mult=  -0.25*(cos(phi2)+1); // --
  }
  return mult;
}
